﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TransportGuideContracts.BindingModels;
using TransportGuideContracts.ViewModels;
using TransportGuideDataModels.Models;

namespace TransportGuideDatabaseImplements.Models
{
	public class TransportType : ITransportTypeModel
	{
		public int Id { get; private set; }

		[Required]
		public string Name { get; private set; } = string.Empty;

		[Required]
		public double Price { get; set; }

		[ForeignKey("TransportTypeId")]
		public virtual List<Route> Routes { get; set; } = new();


		public static TransportType? Create(TransportTypeBindingModel model)
		{
			if (model == null)
			{
				return null;
			}
			return new TransportType()
			{
				Id = model.Id,
				Name = model.Name,
				Price = model.Price
			};
		}
		public static TransportType Create(TransportTypeViewModel model)
		{
			return new TransportType
			{
				Id = model.Id,
				Name = model.Name,
				Price = model.Price
			};
		}
		public void Update(TransportTypeBindingModel model)
		{
			if (model == null)
			{
				return;
			}
			Name = model.Name;
			Price = model.Price;
		}
		public TransportTypeViewModel GetViewModel => new()
		{
			Id = Id,
			Name = Name,
			Price = Price
		};
	}
}
